<?php
/***************************************************************************
 *                              booker_auth.php
 *                            -------------------
 *   begin                : Friday, apr 14, 2006
 *   copyright            : (C) 2006 Thomas Grandjean aka Arnel from server Khaz Modan
 *   email                : tgr@skynet.be
 *   website              : www.rebirthoflight.net
 *
 ***************************************************************************/

/***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 ***************************************************************************/

include_once('./language/lang_' . $userdata['user_lang'] . '/lang_ROLwowtools.php');

$user_id = $userdata['user_id'];
$classe =	$userdata['classe'];

// get booker config

$sql = "SELECT * FROM ROL_config";   

if( !($result = $db->sql_query($sql)) )
{
	message_die(GENERAL_ERROR, 'Can not retrieve Booker config data', '', __LINE__, __FILE__, $sql);
}

while ($config_row = $db->sql_fetchrow($result))
{
	switch ($config_row['param'])
	{
		case 'officers':
			$officers = $config_row['value'];
			break;
		
		case 'members':
			$members = $config_row['value'];
			break;
		
		case 'smallraid':
			$smallraid = ( $config_row['value'] == '1' ) ? true : false;
			break;																						

		case 'lang':
			$wow_lang = $config_row['value'];
			break;

		case 'raidleader':
			$lead = $config_row['value'];
			break;
		
		default:
			break;
	}			
}


// check if the user is an officer

$sql = 'SELECT g.group_id FROM '.USER_GROUP_TABLE.' as l, '.GROUPS_TABLE.' as g
        WHERE l.user_id ='. $user_id.' AND g.group_id = l.group_id AND
        g.group_id IN ('.$officers.')';
      
if ( !($result = $db->sql_query($sql)) ) message_die(GENERAL_ERROR, 'Could not read groups', '', __LINE__, __FILE__, $sql);

if( $row = $db->sql_fetchrow($result) )
{
	$isofficer = true;
	$ismembre = true;
}
else
{
	$isofficer = false;

	// check if the user is a guild member
	
	$sql = 'SELECT g.group_id FROM '.USER_GROUP_TABLE.' as l, '.GROUPS_TABLE.' as g
	        WHERE l.user_id ='. $user_id.' AND g.group_id = l.group_id AND
	        g.group_id IN ('.$members.')';
	      
	if ( !($result = $db->sql_query($sql)) ) message_die(GENERAL_ERROR, 'Could not read groups', '', __LINE__, __FILE__, $sql);
	
	if( $row = $db->sql_fetchrow($result) )
	{
		$ismembre = true;
	}
	else
	{
		$ismembre = false;
	}

}

$rol = '<div align="center" style="font-family: Verdana; font-size: 10px; letter-spacing: -1px">ROL Raid Booker | &copy; 2006 Aranel | <a href="http://www.rebirthoflight.net">Rebirth of Light</a> Guild | Khaz Modan EU</div>';


?>