<?php
/***************************************************************************
 *                              ROLBooker_raid.php
 *                            -------------------
 *   begin                : Friday, apr 14, 2006
 *   copyright            : (C) 2006 Thomas Grandjean aka Arnel from server Khaz Modan
 *   email                : tgr@skynet.be
 *   website              : www.rebirthoflight.net
 *
 ***************************************************************************/

/***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 ***************************************************************************/

define('IN_PHPBB', true);
define('CT_SECLEVEL', 'LOW');
$phpbb_root_path = './';

include($phpbb_root_path . 'extension.inc');
include($phpbb_root_path . 'common.'.$phpEx);

//
// Start session management
//
$userdata = session_pagestart($user_ip, PAGE_INDEX);
init_userprefs($userdata);
//
// End session management
//


$user_id = $userdata['user_id'];
$classe =	$userdata['classe'];
$raidid = $_GET['raidid'];
$action = $_GET['action'];
$membre = $_GET['nommembre'];

include($phpbb_root_path . 'ROLbooker_auth.php');

switch ($wow_lang)
{
	case 'FR':
		// French
		$couleurs = array("Chaman" => "#00DBBA", "Chasseur" => "#aad372", "Demoniste" => "#9382C9", "Druide" => "#ff7c0a", "Guerrier" => "#c69b6d", "Mage" => "#68ccef", "Paladin" => "#f48cba", "Pretre" => "#ffffff", "Voleur" => "#fff468");
		break;
	
	case 'DE':
		$couleurs = array("Druide" => "#ff7c0a", "Jager" => "#aad372", "Magier" => "#68ccef", "Paladin" => "#f48cba", "Priester" => "#ffffff", "Schurke" => "#fff468", "Schamane" => "#00DBBA", "Hexenmeister" => "#9382C9", "Krieger" => "#c69b6d");	
		break;
		
	case 'EN':
		// English (default)
	default:
		$couleurs = array("Druid" => "#ff7c0a", "Hunter" => "#aad372", "Mage" => "#68ccef", "Paladin" => "#f48cba", "Priest" => "#ffffff", "Rogue" => "#fff468", "Shaman" => "#00DBBA", "Warlock" => "#9382C9", "Warrior" => "#c69b6d");	
}


if (empty($_GET['tri']))
{
	$tri ='id';
}
else
{
	$tri = $_GET['tri'];
}

$isowner = false;

$sql = 'SELECT *
	FROM  ROL_booker_raids
	WHERE id = '.$raidid;
	
if ( !($result = $db->sql_query($sql)) )
{
	message_die(GENERAL_ERROR, 'Couldn\'t get raid info', '', __LINE__, __FILE__, $sql);
}
else
{
	$raid_info = $db->sql_fetchrow($result);
	
	if ($user_id == $raid_info['user'])
	{
		$isowner = true;
	}
	else
	{
		$isowner = false;
	}			
}

$isinscrit = false;

$sql = "SELECT *
		FROM ROL_booker_signups
		WHERE raid_id=".$raidid.
	   "  AND name='".$userdata['username']."'";   

if( !($result = $db->sql_query($sql)) )
{
	message_die(GENERAL_ERROR, 'Raid query failed', '', __LINE__, __FILE__, $sql);
}

if( $row = $db->sql_fetchrow($result) )
{
	$isinscrit = true;
}


if (($action == 'del') && (($isofficer) || ($isowner)) && !(is_null($membre)) && !(is_null($raidid)))
{	
	$sql = "UPDATE ROL_booker_signups
			SET  have_acc=0
			WHERE raid_id=".$raidid."
			AND name='".$membre."'";

	if( !$result = $db->sql_query($sql) )
	{
		message_die(GENERAL_ERROR, 'Query Problem!', '', __LINE__, __FILE__, $sql);
	}	
}

if (($action == 'add') && (($isofficer) || ($isowner)) && !(is_null($membre)) && !(is_null($raidid)))
{	
	$sql = "UPDATE ROL_booker_signups
			SET  have_acc=1
			WHERE raid_id=".$raidid."
			AND name='".$membre."'";

	if( !$result = $db->sql_query($sql) )
	{
		message_die(GENERAL_ERROR, 'Query Problem!', '', __LINE__, __FILE__, $sql);
	}	
}

if (($action == 'acceptall') && (($isofficer) || ($isowner)) && !(is_null($raidid)))
{	
	$sql = "UPDATE ROL_booker_signups
			SET  have_acc=1
			WHERE raid_id=".$raidid;

	if( !$result = $db->sql_query($sql) )
	{
		message_die(GENERAL_ERROR, 'Query Problem!', '', __LINE__, __FILE__, $sql);
	}	
}

if (($action == 'refuseall') && (($isofficer) || ($isowner)) && !(is_null($raidid)))
{	
	$sql = "UPDATE ROL_booker_signups
			SET  have_acc=0
			WHERE raid_id=".$raidid;

	if( !$result = $db->sql_query($sql) )
	{
		message_die(GENERAL_ERROR, 'Query Problem!', '', __LINE__, __FILE__, $sql);
	}	
}

if (($action == 'inscrire') && ($ismembre) && !($isinscrit) && !(is_null($membre)) && !(is_null($raidid)))
{	
	$note = $_POST['note'];
	
	$sql = "INSERT INTO ROL_booker_signups (name, raid_id, class, text, have_acc)
			VALUES ('".$membre."',".$raidid.",'".$classe."','".$note."',0)";

	if( !$result = $db->sql_query($sql) )
	{
		message_die(GENERAL_ERROR, 'Query Problem!', '', __LINE__, __FILE__, $sql);
	}	
}

if (($action == 'desinscrire') && ($ismembre) && ($isinscrit) && !(is_null($membre)) && !(is_null($raidid)))
{	
	
	$sql = "DELETE FROM ROL_booker_signups WHERE name='".$membre."' AND raid_id=".$raidid;

	if( !$result = $db->sql_query($sql) )
	{
		message_die(GENERAL_ERROR, 'Query Problem!', '', __LINE__, __FILE__, $sql);
	}	
}

if (($action == 'remove') && (($isofficer) || ($isowner)) && !(is_null($membre)) && !(is_null($raidid)))
{	
	$note = $_POST['note'];
	
	$sql = "DELETE FROM ROL_booker_signups WHERE raid_id=".$raidid." AND name='".$membre."'";
	
//	echo "DEBUG Arnel => ".$sql;
			
	if( !$result = $db->sql_query($sql) )
	{
		message_die(GENERAL_ERROR, 'Query Problem!', '', __LINE__, __FILE__, $sql);
	}	
}

$sql = "SELECT *
		FROM ROL_booker_signups
		WHERE raid_id=".$raidid.
	   "  AND name='".$userdata['username']."'";   

if( !($result = $db->sql_query($sql)) )
{
	message_die(GENERAL_ERROR, 'Query Problem!', '', __LINE__, __FILE__, $sql);
}

$raid_inscription = '';

if( $row = $db->sql_fetchrow($result) )
{
	$image_inscrit = 'OK.gif';
	$texte_inscrit = $lang['ROL_yousubscribed'];
	if ($ismembre)
	{	
		$raid_inscription = '<form method="post" name="form" action="ROLbooker_raid.php?raidid='.$raidid.'&action=desinscrire&tri='.$tri.'&nommembre='.$userdata['username'].'" >&nbsp; &nbsp;<input class="mainoption" type="submit" value="'.$lang['ROL_signout'].'" name="submit"></form>';
	}	
	
}
else
{
	//$image_inscrit = 'NOK.png';
	$image_inscrit = 'NOK.gif';
	$texte_inscrit = $lang['ROL_younotsubscribed'];

	if ($ismembre)
	{	
		$raid_inscription = '<form method="post" name="form" action="ROLbooker_raid.php?raidid='.$raidid.'&action=inscrire&tri='.$tri.'&nommembre='.$userdata['username'].'" >Note:<input type="text" class="post" size=50 MAXLENGTH=50 name="note" value=""/>&nbsp; <input class="mainoption" type="submit" value="'.$lang['ROL_signin'].'" name="submit"></form>';
	}
}


/*
+----------------------------------------------------------
| Start output the page
+----------------------------------------------------------
*/

$page_title = $lang['ROL_name'];

include($phpbb_root_path . 'includes/page_header.'.$phpEx);

if (($isofficer) || ($isowner))
{
	// AFFICHAGE ADMIN
	
	$template->set_filenames(array(
		'body' => 'ROLbooker_raid_admin.tpl')
	);
	
	
	$sql = "SELECT *
			FROM  ROL_booker_raids
			WHERE id=".$raidid;
	
	if( !($result = $db->sql_query($sql)) )
	{
		message_die(GENERAL_ERROR, 'ROL_booker_raids Query problem', '', __LINE__, __FILE__, $sql);
	}
	
	$raid_info = $db->sql_fetchrow($result);
	
	$raid_name = $raid_info['name'];
	$raid_desc = $raid_info['text'];
	$raid_lead = $raid_info['raid_leader'];
	$raid_esti = $raid_info['estimated'];
	$raid_max  = $raid_info['max_signups'];
	$raid_date = $raid_info['date'];	
	
	// Traitement des inscrits et NON accepts
	
	if ($tri == 'nom')
	{		
		$sql = "SELECT *
				FROM ROL_booker_signups
				WHERE raid_id=".$raidid.
			   "  AND have_acc=0
			    ORDER BY name";
	}
	else if ($tri == 'class')
	{
		$sql = "SELECT *
				FROM ROL_booker_signups
				WHERE raid_id=".$raidid.
			   "  AND have_acc=0
			    ORDER BY class";	
	}
	else if ($tri == 'note')
	{
		$sql = "SELECT *
				FROM ROL_booker_signups
				WHERE raid_id=".$raidid.
			   "  AND have_acc=0
			    ORDER BY text";	
	}		
	else if ($tri == 'id')	
	{
		$sql = "SELECT *
				FROM ROL_booker_signups
				WHERE raid_id=".$raidid.
			   "  AND have_acc=0
			    ORDER BY id";	
	}				   
	
	if( !($result = $db->sql_query($sql)) )
	{
		message_die(GENERAL_ERROR, 'ROL_booker_signups Query problem', '', __LINE__, __FILE__, $sql);
	}
	
	$pasincritsrow = array();
	
	while( $row = $db->sql_fetchrow($result) )
	{
		$pasincritsrow[] = $row;
	}
	
	
	for ($i = 0; $i < count($pasincritsrow); $i++)
	{		
			$classe = $pasincritsrow[$i]['class'];
			$nom = '<span style="color:'.$couleurs[$classe].'">'.$pasincritsrow[$i]['name'].'</span>';	
			$texte =  '<span style="color:'.$couleurs[$classe].'">'.$pasincritsrow[$i]['text'].'</span>';	
		
			$class_pic = '<img src="./images/ROLbooker/class_'.$wow_lang.'/'.$classe.'_icon.gif" width="20" height="20" border="0" title="'.$pasincritsrow[$i]['class'].'" />';
			$add_pic = '<a href=ROLbooker_raid.php?raidid='.$raidid.'&action=add&tri='.$tri.'&nommembre='.$pasincritsrow[$i]['name'].'><img src="./images/ROLbooker/b_add.png" border="0" title="'.$lang['ROL_accept'].' '.$pasincritsrow[$i]['name'].'" />';
			$remove_pic = '<a href=ROLbooker_raid.php?raidid='.$raidid.'&action=remove&tri='.$tri.'&nommembre='.$pasincritsrow[$i]['name'].'><img src="./images/ROLbooker/b_del.png" border="0" title="'.$lang['ROL_kick'].' '.$pasincritsrow[$i]['name'].'!" />';
			 
			$template->assign_block_vars('pasincritsrow', array(
				'ROW_CLASS' => ( !($i % 2) ) ? $theme['td_class1'] : $theme['td_class2'],
				'NUM' => $i+1,
				'NOM_MEMBRE' => $nom,
				'TEXTE_MEMBRE' => $texte,
				'CLASSE_MEMBRE' => $class_pic,
				'ADD_PIC' => $add_pic,
				'REMOVE_PIC' => $remove_pic)						
			);
		}
					
		// Traitement des inscrits et accepts
	
	if ($tri == 'nom')
	{		
		$sql = "SELECT *
				FROM ROL_booker_signups
				WHERE raid_id=".$raidid.
			   "  AND have_acc=1
			    ORDER BY name";
	}
	else if ($tri == 'class')
	{
		$sql = "SELECT *
				FROM ROL_booker_signups
				WHERE raid_id=".$raidid.
			   "  AND have_acc=1
			    ORDER BY class";	
	}
	else if ($tri == 'note')
	{
		$sql = "SELECT *
				FROM ROL_booker_signups
				WHERE raid_id=".$raidid.
			   "  AND have_acc=1
			    ORDER BY text";	
	}
	else if ($tri == 'id')	
	{
		$sql = "SELECT *
				FROM ROL_booker_signups
				WHERE raid_id=".$raidid.
			   "  AND have_acc=1
			    ORDER BY id";	
	}		   
	
	if( !($result = $db->sql_query($sql)) )
	{
		message_die(GENERAL_ERROR, 'ROL_booker_signups Query problem', '', __LINE__, __FILE__, $sql);
	}
	
	$incritsrow = array();
	
	while( $row = $db->sql_fetchrow($result) )
	{
		$incritsrow[] = $row;
	}
	
	
	for ($i = 0; $i < count($incritsrow); $i++)
	{		
			$classe = $incritsrow[$i]['class'];
			$nom = '<span style="color:'.$couleurs[$classe].'">'.$incritsrow[$i]['name'].'</span>';	
			$texte =  '<span style="color:'.$couleurs[$classe].'">'.$incritsrow[$i]['text'].'</span>';	
		
			$class_pic = '<img src="./images/ROLbooker/class_'.$wow_lang.'/'.$classe.'_icon.gif" width="20" height="20" border="0" title="'.$incritsrow[$i]['class'].'" />';
			$del_pic = '<a href=ROLbooker_raid.php?raidid='.$raidid.'&action=del&tri='.$tri.'&nommembre='.$incritsrow[$i]['name'].'><img src="./images/ROLbooker/b_add.png" border="0" title="'.$lang['ROL_refuse'].' '.$incritsrow[$i]['name'].'" />';
			
			 
			$template->assign_block_vars('incritsrow', array(
				'ROW_CLASS' => ( !($i % 2) ) ? $theme['td_class1'] : $theme['td_class2'],
				'NUM' => $i+1,
				'NOM_MEMBRE' => $nom,
				'TEXTE_MEMBRE' => $texte,
				'CLASSE_MEMBRE' => $class_pic,
				'DEL_PIC' => $del_pic)						
			);
		}		
}

else
// AFFICHAGE PUBLIC
{
	$template->set_filenames(array(
		'body' => 'ROLbooker_raid.tpl')
	);
	
	$sql = "SELECT *
			FROM  ROL_booker_raids
			WHERE id=".$raidid;
	
	if( !($result = $db->sql_query($sql)) )
	{
		message_die(GENERAL_ERROR, 'ROL_booker_raids Query problem', '', __LINE__, __FILE__, $sql);
	}
	
	$raid_info = $db->sql_fetchrow($result);
	
	$raid_name = $raid_info['name'];
	$raid_desc = $raid_info['text'];
	$raid_lead = $raid_info['raid_leader'];
	$raid_esti = $raid_info['estimated'];
	$raid_max  = $raid_info['max_signups'];
	$raid_date = $raid_info['date'];
	


	// Traitement des inscrits et NON accepts
	
	if ($tri == 'nom')
	{		
		$sql = "SELECT *
				FROM ROL_booker_signups
				WHERE raid_id=".$raidid.
			   "  AND have_acc=0
			    ORDER BY name";
	}
	else if ($tri == 'class')
	{
		$sql = "SELECT *
				FROM ROL_booker_signups
				WHERE raid_id=".$raidid.
			   "  AND have_acc=0
			    ORDER BY class";	
	}
	else if ($tri == 'note')
	{
		$sql = "SELECT *
				FROM ROL_booker_signups
				WHERE raid_id=".$raidid.
			   "  AND have_acc=0
			    ORDER BY text";	
	}		
	else if ($tri == 'id')	
	{
		$sql = "SELECT *
				FROM ROL_booker_signups
				WHERE raid_id=".$raidid.
			   "  AND have_acc=0
			    ORDER BY id";	
	}				   
	
	if( !($result = $db->sql_query($sql)) )
	{
		message_die(GENERAL_ERROR, 'ROL_booker_signups Query problem', '', __LINE__, __FILE__, $sql);
	}
	
	$pasincritsrow = array();
	
	while( $row = $db->sql_fetchrow($result) )
	{
		$pasincritsrow[] = $row;
	}
	
	
	for ($i = 0; $i < count($pasincritsrow); $i++)
	{		
			$classe = $pasincritsrow[$i]['class'];
			$nom = '<span style="color:'.$couleurs[$classe].'">'.$pasincritsrow[$i]['name'].'</span>';	
			$texte =  '<span style="color:'.$couleurs[$classe].'">'.$pasincritsrow[$i]['text'].'</span>';	
		
			$class_pic = '<img src="./images/ROLbooker/class_'.$wow_lang.'/'.$classe.'_icon.gif" width="20" height="20" border="0" title="'.$pasincritsrow[$i]['class'].'" />';
			$template->assign_block_vars('pasincritsrow', array(
				'ROW_CLASS' => ( !($i % 2) ) ? $theme['td_class1'] : $theme['td_class2'],
				'NUM' => $i+1,
				'NOM_MEMBRE' => $nom,
				'TEXTE_MEMBRE' => $texte,
				'CLASSE_MEMBRE' => $class_pic)						
			);
		}
					
		// Traitement des inscrits et accepts
	
	if ($tri == 'nom')
	{		
		$sql = "SELECT *
				FROM ROL_booker_signups
				WHERE raid_id=".$raidid.
			   "  AND have_acc=1
			    ORDER BY name";
	}
	else if ($tri == 'class')
	{
		$sql = "SELECT *
				FROM ROL_booker_signups
				WHERE raid_id=".$raidid.
			   "  AND have_acc=1
			    ORDER BY class";	
	}
	else if ($tri == 'note')
	{
		$sql = "SELECT *
				FROM ROL_booker_signups
				WHERE raid_id=".$raidid.
			   "  AND have_acc=1
			    ORDER BY text";	
	}
	else if ($tri == 'id')	
	{
		$sql = "SELECT *
				FROM ROL_booker_signups
				WHERE raid_id=".$raidid.
			   "  AND have_acc=1
			    ORDER BY id";	
	}		   
	
	if( !($result = $db->sql_query($sql)) )
	{
		message_die(GENERAL_ERROR, 'ROL_booker_signups Query problem', '', __LINE__, __FILE__, $sql);
	}
	
	$incritsrow = array();
	
	while( $row = $db->sql_fetchrow($result) )
	{
		$incritsrow[] = $row;
	}
	
	
	for ($i = 0; $i < count($incritsrow); $i++)
	{		
			$classe = $incritsrow[$i]['class'];
			$nom = '<span style="color:'.$couleurs[$classe].'">'.$incritsrow[$i]['name'].'</span>';	
			$texte =  '<span style="color:'.$couleurs[$classe].'">'.$incritsrow[$i]['text'].'</span>';	
		
			$class_pic = '<img src="./images/ROLbooker/class_'.$wow_lang.'/'.$classe.'_icon.gif" width="20" height="20" border="0" title="'.$incritsrow[$i]['class'].'" />';
			 
			$template->assign_block_vars('incritsrow', array(
				'ROW_CLASS' => ( !($i % 2) ) ? $theme['td_class1'] : $theme['td_class2'],
				'NUM' => $i+1,
				'NOM_MEMBRE' => $nom,
				'TEXTE_MEMBRE' => $texte,
				'CLASSE_MEMBRE' => $class_pic)						
			);
		}		
}


// rpartition des classes

switch ($wow_lang)
{
	case 'FR':

				$tab_classes = array(	"classe" => array(0 => "Chaman", 1 => "Chasseur", 2 => "Demoniste", 3 => "Druide", 4 => "Guerrier", 5 => "Mage", 6 => "Paladin", 7 => "Pretre", 8 => "Voleur"),
															"acceptes" => array(0 => 0, 1 => 0, 2 => 0, 3 => 0, 4 => 0, 5 => 0, 6 => 0, 7 => 0, 8 => 0),
															"inscrits" => array(0 => 0, 1 => 0, 2 => 0, 3 => 0, 4 => 0, 5 => 0, 6 => 0, 7 => 0, 8 => 0)
														);

				for ($i = 0; $i < count($incritsrow); $i++)
				{
					
					if ($incritsrow[$i]['class'] == 'Chaman')
						$tab_classes['acceptes'][0]++;							
					if ($incritsrow[$i]['class'] == 'Chasseur')
						$tab_classes['acceptes'][1]++;
					if ($incritsrow[$i]['class'] == 'Demoniste')
						$tab_classes['acceptes'][2]++;
					if ($incritsrow[$i]['class'] == 'Druide')
						$tab_classes['acceptes'][3]++;
					if ($incritsrow[$i]['class'] == 'Guerrier')
						$tab_classes['acceptes'][4]++;
					if ($incritsrow[$i]['class'] == 'Mage')
						$tab_classes['acceptes'][5]++;
					if ($incritsrow[$i]['class'] == 'Paladin')
						$tab_classes['acceptes'][6]++;
					if ($incritsrow[$i]['class'] == 'Pretre')
						$tab_classes['acceptes'][7]++;
					if ($incritsrow[$i]['class'] == 'Voleur')
						$tab_classes['acceptes'][8]++;		
																
				}				

				for ($i = 0; $i < count($pasincritsrow); $i++)
				{
					if ($pasincritsrow[$i]['class'] == 'Chaman')
						$tab_classes['inscrits'][0]++;							
					if ($pasincritsrow[$i]['class'] == 'Chasseur')
						$tab_classes['inscrits'][1]++;
					if ($pasincritsrow[$i]['class'] == 'Demoniste')
						$tab_classes['inscrits'][2]++;
					if ($pasincritsrow[$i]['class'] == 'Druide')
						$tab_classes['inscrits'][3]++;
					if ($pasincritsrow[$i]['class'] == 'Guerrier')
						$tab_classes['inscrits'][4]++;
					if ($pasincritsrow[$i]['class'] == 'Mage')
						$tab_classes['inscrits'][5]++;
					if ($pasincritsrow[$i]['class'] == 'Paladin')
						$tab_classes['inscrits'][6]++;
					if ($pasincritsrow[$i]['class'] == 'Pretre')
						$tab_classes['inscrits'][7]++;
					if ($pasincritsrow[$i]['class'] == 'Voleur')
						$tab_classes['inscrits'][8]++;																		
				}																
		break;

	case 'EN':

				$tab_classes = array(	"classe" => array(0 => "Shaman", 1 => "Hunter", 2 => "Warlock", 3 => "Druid", 4 => "Warrior", 5 => "Mage", 6 => "Paladin", 7 => "Priest", 8 => "Rogue"),
															"acceptes" => array(0 => 0, 1 => 0, 2 => 0, 3 => 0, 4 => 0, 5 => 0, 6 => 0, 7 => 0, 8 => 0),
															"inscrits" => array(0 => 0, 1 => 0, 2 => 0, 3 => 0, 4 => 0, 5 => 0, 6 => 0, 7 => 0, 8 => 0)
														);

				for ($i = 0; $i < count($incritsrow); $i++)
				{
					
					if ($incritsrow[$i]['class'] == 'Shaman')
						$tab_classes['acceptes'][0]++;							
					if ($incritsrow[$i]['class'] == 'Hunter')
						$tab_classes['acceptes'][1]++;
					if ($incritsrow[$i]['class'] == 'Warlock')
						$tab_classes['acceptes'][2]++;
					if ($incritsrow[$i]['class'] == 'Druid')
						$tab_classes['acceptes'][3]++;
					if ($incritsrow[$i]['class'] == 'Warrior')
						$tab_classes['acceptes'][4]++;
					if ($incritsrow[$i]['class'] == 'Mage')
						$tab_classes['acceptes'][5]++;
					if ($incritsrow[$i]['class'] == 'Paladin')
						$tab_classes['acceptes'][6]++;
					if ($incritsrow[$i]['class'] == 'Priest')
						$tab_classes['acceptes'][7]++;
					if ($incritsrow[$i]['class'] == 'Rogue')
						$tab_classes['acceptes'][8]++;		
																
				}				

				for ($i = 0; $i < count($pasincritsrow); $i++)
				{
					if ($pasincritsrow[$i]['class'] == 'Shaman')
						$tab_classes['inscrits'][0]++;							
					if ($pasincritsrow[$i]['class'] == 'Hunter')
						$tab_classes['inscrits'][1]++;
					if ($pasincritsrow[$i]['class'] == 'Warlock')
						$tab_classes['inscrits'][2]++;
					if ($pasincritsrow[$i]['class'] == 'Druid')
						$tab_classes['inscrits'][3]++;
					if ($pasincritsrow[$i]['class'] == 'Warrior')
						$tab_classes['inscrits'][4]++;
					if ($pasincritsrow[$i]['class'] == 'Mage')
						$tab_classes['inscrits'][5]++;
					if ($pasincritsrow[$i]['class'] == 'Paladin')
						$tab_classes['inscrits'][6]++;
					if ($pasincritsrow[$i]['class'] == 'Priest')
						$tab_classes['inscrits'][7]++;
					if ($pasincritsrow[$i]['class'] == 'Rogue')
						$tab_classes['inscrits'][8]++;																		
				}																
		break;		
		
	case 'DE':

				$tab_classes = array(	"classe" => array(0 => "Schamane", 1 => "Jager", 2 => "Hexenmeister", 3 => "Druide", 4 => "Krieger", 5 => "Magier", 6 => "Paladin", 7 => "Priester", 8 => "Schurke"),
															"acceptes" => array(0 => 0, 1 => 0, 2 => 0, 3 => 0, 4 => 0, 5 => 0, 6 => 0, 7 => 0, 8 => 0),
															"inscrits" => array(0 => 0, 1 => 0, 2 => 0, 3 => 0, 4 => 0, 5 => 0, 6 => 0, 7 => 0, 8 => 0)
														);

				for ($i = 0; $i < count($incritsrow); $i++)
				{
					
					if ($incritsrow[$i]['class'] == 'Schamane')
						$tab_classes['acceptes'][0]++;							
					if ($incritsrow[$i]['class'] == 'Jager')
						$tab_classes['acceptes'][1]++;
					if ($incritsrow[$i]['class'] == 'Hexenmeister')
						$tab_classes['acceptes'][2]++;
					if ($incritsrow[$i]['class'] == 'Druide')
						$tab_classes['acceptes'][3]++;
					if ($incritsrow[$i]['class'] == 'Krieger')
						$tab_classes['acceptes'][4]++;
					if ($incritsrow[$i]['class'] == 'Magier')
						$tab_classes['acceptes'][5]++;
					if ($incritsrow[$i]['class'] == 'Paladin')
						$tab_classes['acceptes'][6]++;
					if ($incritsrow[$i]['class'] == 'Priester')
						$tab_classes['acceptes'][7]++;
					if ($incritsrow[$i]['class'] == 'Schurke')
						$tab_classes['acceptes'][8]++;		
																
				}				

				for ($i = 0; $i < count($pasincritsrow); $i++)
				{
					if ($pasincritsrow[$i]['class'] == 'Schamane')
						$tab_classes['inscrits'][0]++;							
					if ($pasincritsrow[$i]['class'] == 'Jager')
						$tab_classes['inscrits'][1]++;
					if ($pasincritsrow[$i]['class'] == 'Hexenmeister')
						$tab_classes['inscrits'][2]++;
					if ($pasincritsrow[$i]['class'] == 'Druide')
						$tab_classes['inscrits'][3]++;
					if ($pasincritsrow[$i]['class'] == 'Krieger')
						$tab_classes['inscrits'][4]++;
					if ($pasincritsrow[$i]['class'] == 'Magier')
						$tab_classes['inscrits'][5]++;
					if ($pasincritsrow[$i]['class'] == 'Paladin')
						$tab_classes['inscrits'][6]++;
					if ($pasincritsrow[$i]['class'] == 'Priester')
						$tab_classes['inscrits'][7]++;
					if ($pasincritsrow[$i]['class'] == 'Schurke')
						$tab_classes['inscrits'][8]++;																		
				}																
		break;				
}
				
for ($i = 0; $i < 9; $i++)
{			
		$pourc1 = "??";
		if ($raid_max > 0)
		{
			$pourc1 = ($tab_classes['acceptes'][$i] * 100 / $raid_max );
		}
		$pourc2 = "??";
		if ($raid_max > 0)
		{
			$pourc2 = ($tab_classes['inscrits'][$i] * 100 / $raid_max );
		}
		
		$template->assign_block_vars('repartrow', array(
			'ROW_CLASS' => ( !($i % 2) ) ? $theme['td_class1'] : $theme['td_class2'],
			'REP_PIC' => '<img src="./images/ROLbooker/class_'.$wow_lang.'/'.$tab_classes['classe'][$i].'_icon.gif" width="20" height="20" border="0" alt="'.$tab_classes['classe'][$i].'" />',
			'REP_CLASSE' => '<span style="color:'.$couleurs[$tab_classes['classe'][$i]].'">'.$tab_classes['classe'][$i].'</span>',
			'REP_NOMBRE2' => '<span style="color:'.$couleurs[$tab_classes['classe'][$i]].'">'.$tab_classes['inscrits'][$i].'</span>',
			'REP_POURC2' => '<span style="color:'.$couleurs[$tab_classes['classe'][$i]].'">'.$pourc2.' %</span>',
			'REP_NOMBRE1' => '<span style="color:'.$couleurs[$tab_classes['classe'][$i]].'">'.$tab_classes['acceptes'][$i].'</span>',
			'REP_POURC1' => '<span style="color:'.$couleurs[$tab_classes['classe'][$i]].'">'.$pourc1.' %</span>',
			'REP_COUL' => $couleurs[$tab_classes['classe'][$i]]
			)						
		);
}

$acceptall = '';
$refuseall = '';

if ((count($pasincritsrow))>0)
	$acceptall = '<form method="post" name="form" action="ROLbooker_raid.php?raidid='.$raidid.'&action=acceptall&tri='.$tri.'" ><input class="mainoption" type="submit" value="'.$lang['ROL_acceptall'].'" name="submit"></form>';

if ((count($incritsrow))>0)
	$refuseall = '<form method="post" name="form" action="ROLbooker_raid.php?raidid='.$raidid.'&action=refuseall&tri='.$tri.'" ><input class="mainoption" type="submit" value="'.$lang['ROL_refuseall'].'" name="submit"></form>';


$template->assign_vars(array(
	'RAID_ID' => $raidid,
	'RAID_NAME' => $raid_name,
	'RAID_DESC' => $raid_desc,
	'RAID_DATE' => (!empty($raid_date)) ? create_date("l j F Y, G:i", $raid_date, $board_config['board_timezone']) : '',
	'RAID_LEAD' => $raid_lead,
	'RAID_ESTI' => $raid_esti,
	'RAID_MAX' => $raid_max,
	'ROL' => $rol,
	'ACCEPT_ALL' => $acceptall,
	'REFUSE_ALL' => $refuseall,
	'RAID' => $lang['ROL_raid'],
	'DURATION' => $lang['ROL_durationestimation'],
	'RAIDLEADER' => $lang['ROL_raidleader'],
	'MAX' => $lang['ROL_maxplayers'],
	'SIGNEDUP' => $lang['ROL_signedup'],
	'ACCEPTED' => $lang['ROL_accepted'],
	'SUBSCRIBED' => $lang['ROL_subscribed'],
	'DESC' => $lang['ROL_description'],
	'CLASS' => $lang['ROL_class'],
	'DATE' => $lang['ROL_date'],
	'SUBSCRIBERS' => $lang['ROL_subscribers'],
	'ACCEPTED' => $lang['ROL_accepted'],
	'MEMBER' => $lang['ROL_member'],
	'CL' => $lang['ROL_class_abrev'],
	'NOTE' => $lang['ROL_note'],
	'INFO' => $lang['ROL_inforaid'],
	'BOOKER' => $lang['ROL_name'],
	'TOTAL_OUI' => count($incritsrow),
	'TOTAL_NON' => count($pasincritsrow),
	'RAID_INSCRIT' => $texte_inscrit,
	'RAID_INSCRIT_PIC' => $image_inscrit,
	'RAID_INSCRIPTION' => $raid_inscription)
);

//
// Generate the page
//

$template->pparse('body');

include($phpbb_root_path . 'includes/page_tail.'.$phpEx);


?>