<?php
/***************************************************************************
 *                             admin_ROLbooker.php
 *                             -------------------
 *   begin                : Thursday, Nov 31, 2006
 *   copyright            : (C) 2006 Rebirth of Light Guild
 *   coder                : Thomas Grandjean aka Arnel aka Whisky
 *   email                : aranel@rebirthoflight.net
 *
 ***************************************************************************/

/***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 ***************************************************************************/

define('IN_PHPBB', 1);

if ( !empty($setmodules) )
{
	$filename = basename(__FILE__);
	$module['ROL WoW Tools']['Raid Booker'] = $filename;

	return;
}

//print "BROL = ". $HTTP_POST_VARS['smallraid'];

//
// Load default header
//
$phpbb_root_path = './../';
require($phpbb_root_path . 'extension.inc');
require('./pagestart.' . $phpEx);

include($phpbb_root_path.'language/lang_' . $board_config['default_lang'] . '/lang_ROLwowtools.'.$phpEx);


if ( isset($HTTP_POST_VARS['ROL_update']))
		
{
		if ( isset($HTTP_POST_VARS['langselect']))		
		{	
			$sql = "UPDATE ROL_config SET value = '" . $HTTP_POST_VARS['langselect'] . "' WHERE TYPE='booker' AND param='lang'";
			
			if ( !$db->sql_query($sql) )
			{
				message_die(GENERAL_ERROR, 'Could not update Small raid  data', '', __LINE__, __FILE__, $sql);
			}	
		}	
	
		if ( isset($HTTP_POST_VARS['officers']))		
		{	
			$sql = "UPDATE ROL_config SET value = '" . $HTTP_POST_VARS['officers'] . "' WHERE TYPE='booker' AND param='officers'";
			
			if ( !$db->sql_query($sql) )
			{
				message_die(GENERAL_ERROR, 'Could not update offciers data', '', __LINE__, __FILE__, $sql);
			}	
		}

		if ( isset($HTTP_POST_VARS['members']))		
		{	
			$sql = "UPDATE ROL_config SET value = '" . $HTTP_POST_VARS['members'] . "' WHERE TYPE='booker' AND param='members'";
			
			if ( !$db->sql_query($sql) )
			{
				message_die(GENERAL_ERROR, 'Could not update members data', '', __LINE__, __FILE__, $sql);
			}	
		}

		if ( isset($HTTP_POST_VARS['raidleader']))		
		{	
			$sql = "UPDATE ROL_config SET value = '" . $HTTP_POST_VARS['raidleader'] . "' WHERE TYPE='booker' AND param='raidleader'";
			
			if ( !$db->sql_query($sql) )
			{
				message_die(GENERAL_ERROR, 'Could not update members data', '', __LINE__, __FILE__, $sql);
			}	
		}

		if ( isset($HTTP_POST_VARS['smallraid']))		
		{	
			if ($HTTP_POST_VARS['smallraid']=='on')
				{$val = 1;}
			else
				{$val = 0;}						
			$sql = "UPDATE ROL_config SET value = '" . $val . "' WHERE TYPE='booker' AND param='smallraid'";
			
			if ( !$db->sql_query($sql) )
			{
				message_die(GENERAL_ERROR, 'Could not update Small raid  data', '', __LINE__, __FILE__, $sql);
			}	
		}
			
}

	//
	// DISPLAY THE CONFIG OPTIONS
	//
	$template->set_filenames(array(
		'body' => 'admin/admin_ROLbooker.tpl')
	);

		$sql = "SELECT * FROM ROL_config WHERE TYPE='booker'";
		
		if ( !($result = $db->sql_query($sql)) )
		{
			message_die(GENERAL_ERROR, 'Error ROL booker Config information', '', __LINE__, __FILE__, $sql);
		}

		while ($config_row = $db->sql_fetchrow($result))
		{
			switch ($config_row['param'])
			{
				case 'lang':
					$langbooker = $config_row['value'];
					break;
	
				case 'officers':
					$officers = $config_row['value'];
					break;
				
				case 'members':
					$members = $config_row['value'];
					break;
								
				case 'smallraid':
					$smallraid = ( $config_row['value'] == '1' ) ? ' checked value=1' : '';
					break;																						

				case 'raidleader':
					$raidleader = $config_row['value'];
					break;	
				
				default:
					break;
			}		
			
		}

	//$s_hidden_fields = '<input type="hidden" name="mode" value="' . $mode . '" /><input type="hidden" name="' . POST_GROUPS_URL . '" value="' . $group_id . '" />';
	
	$lang_select = '<select name="langselect">';
	$lang_select .= '<option value="FR"'; if ($langbooker=='FR') $lang_select .= ' selected="selected"'; $lang_select .= ' >Franais</option>';
	$lang_select .= '<option value="EN"'; if ($langbooker=='EN') $lang_select .= ' selected="selected"'; $lang_select .= ' >English</option>';
	$lang_select .= '<option value="DE"'; if ($langbooker=='DE') $lang_select .= ' selected="selected"'; $lang_select .= ' >Deutsch</option>';
	$lang_select .= '</select>';
	
	$template->assign_vars(array(
		'S_ROL_ACTION' => append_sid("admin_ROLbooker.$phpEx"),
		'LANG_SELECT' => $lang_select,
		'OFFICERS' => $officers,
		'MEMBERS' => $members,
		'L_LANG' => $lang['ROL_lang'],
		'L_LANG_DESC' => $lang['ROL_lang_desc'],
		'SMALLRAID_STATE' => $smallraid,
		'L_ROL_OFFICERS' => $lang['ROL_officers'],
		'L_ROL_LEADER' => $lang['ROL_raidleader'],
		'L_ROL_LEADER_DESC' => $lang['ROL_raidleader_desc'],
		'LEADER' => $raidleader,
		'L_ROL_TITLE' => $lang['ROL_admin_title'],
		'L_ROL_PARAMS' => $lang['ROL_params'],
		'L_ROL_MEMBERS' => $lang['ROL_members'],			
		'L_ROL_EXPLAIN' => $lang['ROL_booker_explain'],
		'L_ROL_OFFICERS_DESC' => $lang['ROL_officers_desc'],
		'L_ROL_MEMBERS_DESC' => $lang['ROL_members_desc'],
		'L_ROL_YES' => $lang['ROL_yes'],
		'L_ROL_SMALL_RAID_ACTIVATE' => $lang['ROL_small_raid_activate'],
		'L_ROL_SMALL_RAID_DESC' => $lang['ROL_small_raid_desc'],
		'L_SAVE' => $lang['ROL_save'],
		'L_UNDO' => $lang['ROL_undo'])		

//		'S_HIDDEN_FIELDS' => $s_hidden_fields)
	);

	$template->pparse('body');

include('./page_footer_admin.'.$phpEx);

?>
